<template>
  <div>
    <v-row justify="center">
      <v-col md="12">
        <div class="title text-center">Visualizador de documentos</div>
        <div class="text-center">Comienza localizando el documento</div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="8">
        <Etiquetas
          v-model="etiqueta"
          :disabled="loading"
          :searchAction="getFoliosEtiquetaBusquedas"
        />
        <DirectorioArbol
          ref="directorioArbol"
          :disabled="loading"
          v-model="directorioArbol"
        />
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <div v-if="etiquetaSearched && etiquetaSearched.descripcion">
          <span class="text-subtitle-2"
            >Documentos asociados a la etiqueta:
          </span>
          <v-chip x-small color="blue-grey" class="white--text">
            <span> {{ etiquetaSearched.descripcion }}</span>
          </v-chip>
        </div>
        <div v-if="directorioArbol && directorioArbol.descripcion">
          <span class="text-subtitle-2"
            ><strong>Documentos asociados del paso: </strong></span
          >
          <v-chip x-small color="blue-grey" class="white--text">
            <span> {{ directorioArbol.descripcion }}</span>
          </v-chip>
        </div>
        <div class="gris">
          <v-data-table
            :headers="headers"
            :items="data"
            item-key="idFolio"
            :loading="loading"
            :height="350"
            :dense="true"
            :fixed-header="true"
            class="custom-table"
            hide-default-footer
          >
            <template v-slot:item.documento.titulo="{ item }" }>
              <router-link class="link" :to="to(item)">
                {{ item.documento.titulo }}
              </router-link>
            </template>
            <template v-slot:item.unidadesNegocio="{ item }" }>
              <template v-if="item.unidadesNegocio.length > 0">
                <template v-if="item.unidadesNegocio.length == 1">
                  {{ item.unidadesNegocio[0].descripcion }}
                </template>
                <template v-else>
                  <div class="mt-2" style="display: inline-block">
                    {{ item.unidadesNegocio[0].descripcion }}
                  </div>
                  <v-menu bottom left>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        class="float-rigth"
                        right
                        fab
                        dark
                        x-small
                        dense
                        :elevation="0"
                        color="grey"
                        v-bind="attrs"
                        v-on="on"
                      >
                        <v-icon>mdi-dots-vertical</v-icon>
                      </v-btn>
                    </template>
                    <v-list>
                      <template
                        v-for="(itemUnidadNegocio, i) in item.unidadesNegocio"
                      >
                        <v-list-item v-if="i > 0" :key="i">
                          <v-list-item-title>{{
                            itemUnidadNegocio.descripcion
                          }}</v-list-item-title>
                        </v-list-item>
                      </template>
                    </v-list>
                  </v-menu>
                </template>
              </template>
              <template v-else>
                <span class="text--disabled">N/A</span>
              </template>
            </template>
            <template v-slot:item.estado.descripcion="{ item }" }>
              <span :class="classEstado(item.estado.idEstadoFolio)">{{
                item.estado.descripcion
              }}</span>
            </template>
          </v-data-table>
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <div v-if="etiquetaSearched && etiquetaSearched.descripcion">
          <template v-if="etiquetasRelacionadas.length > 0">
            <span class="text-subtitle-2"
              ><strong>Quizás también te interesen otros tags: </strong></span
            >
            <br />
            <template
              v-for="(etiquetaRelacionada, index) in etiquetasRelacionadas"
            >
              <v-chip
                :key="index"
                link
                color="blue-grey"
                class="white--text rounded-0 mb-1 mr-2"
                @click="selectTagAndSearch(etiquetaRelacionada)"
              >
                <span> {{ etiquetaRelacionada.descripcion }}</span>
              </v-chip>
            </template>
            <v-divider></v-divider>
          </template>
          <template v-else>
            <span class="text-subtitle-2"
              ><strong>No se encontraron etiquetas realacionadas </strong></span
            >
          </template>
        </div>
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import store from "@/store";
import Etiquetas from "@/views/secure/modelo-negocio/documentos/visualizador/folios/etiqueta-arbol/components/Etiquetas.vue";
import DirectorioArbol from "@/views/secure/modelo-negocio/documentos/visualizador/folios/etiqueta-arbol/components/DirectorioArbol.vue";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-TablaFoliosEtiquetaArbol",
  components: {
    Etiquetas,
    DirectorioArbol,
  },
  data: (vm) => ({
    data: [],
    directorioArbol: null,
    loading: false,
    itemsPerPage: 10,
    etiqueta: null,
    etiquetasRelacionadas: [],
    etiquetaSearched: {},
    headers: [
      {
        text: "Folio",
        value: "idFolio",
        align: "center",
      },
      { text: "Documento", value: "documento.titulo", align: "center" },
      {
        text: "Unidad(es) de Negocio",
        value: "unidadesNegocio",
        align: "center",
      },
      { text: "Documentador", value: "creador.nombre", align: "center" },
      { text: "Estado", value: "estado.descripcion", align: "center" },
    ],
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  watch: {
    etiqueta(val) {
      if (!val) {
        this.data = [];
      }
    },
    directorioArbol(val, pre) {
      if (val) {
        this.getFoliosNivelModeloBusquedas();
      } else {
        this.data = [];
      }
    },
  },
  methods: {
    clear() {
      if (this.$refs.directorioArbol) {
        this.$refs.directorioArbol.clear();
      }
    },
    to(folio) {
      return {
        name: "modelo_negocio_documentos_visualizar_resumen_folio",
        query: {
          back: serviceCommons.objectToBase64({
            name: "modelo_negocio_documentos_visualizador",
          }),
        },
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
          }),
        },
      };
    },
    classEstado(idEstadoFolio) {
      if (idEstadoFolio == 2) {
        return { "documentar--text": true };
      }
      if (idEstadoFolio == 3) {
        return { "revisar--text": true };
      }
      if (idEstadoFolio == 4) {
        return { "autorizar--text": true };
      }
      if (idEstadoFolio == 5) {
        return { "publicado--text": true };
      }
    },
    getFoliosNivelModeloBusquedas() {
      const self = this;
      this.loading = true;
      this.etiquetaSearched = {};
      this.etiqueta = null;
      axios(
        "/modelo-negocio/folios/v1/busquedas/modelos-negocio/" +
          this.directorioArbol.idArbol
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.data = data.resultado.folios;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
    getFoliosEtiquetaBusquedas() {
      if (this.etiqueta) {
        const self = this;
        this.loading = true;
        this.etiquetaSearched = JSON.parse(JSON.stringify(this.etiqueta));
        this.clear();
        this.getEtiquetasRelacionadas();
        axios(
          "/modelo-negocio/folios/v1/busquedas/etiquetas/" +
            this.etiqueta.idEtiqueta
        )
          .then((response) => {
            let data = response.data;
            if (data) {
              self.data = data.resultado.folios;
            }
          })
          .catch((error) => {
            if (error.response && error.response.status == 404) {
              self.data = [];
            } else {
              console.log(error);
            }
          })
          .finally(() => {
            self.loading = false;
          });
      }
    },
    getEtiquetasRelacionadas() {
      const self = this;
      axios(
        "/modelo-negocio/catalogos/etiquetas/v1/" +
          this.etiqueta.idEtiqueta +
          "/relacionadas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.etiquetasRelacionadas = data.resultado.etiquetas;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.etiquetasRelacionadas = [];
          } else {
            console.log(error);
          }
        });
    },
    selectTagAndSearch(etiqueta) {
      this.etiqueta = etiqueta;
      this.getFoliosEtiquetaBusquedas();
    },
  },
};
</script>
